#-*- coding:Utf-8 -*-

import pygame 
from pygame.locals import *
from random import randrange 

pygame.init()


screen = pygame.display.set_mode((600,600))


couleur_sombre = [(0,90,0), (155,0,0), (0,55,125), (160,150,0)]
couleur_clair = [(0,225,0), (243,0,0), (0,205,255), (255,255,0)]
blanc, noir , gris = (255,255,255), (0,0,0), (40,40,40)
liste_pos = [((0,0),(250,250)) , ((250,0),(250,250)) , ((0,250),(250,250)) , ((250,250),(250,250))]
font_char = ['data/Fonts/ARCADE_I.TTF','data/Fonts/Computerfont.ttf','data/Fonts/Digit.TTF','data/Fonts/fast_money.ttf']

class Texte :
    '''______Afficher un texte_____
       les attributs : 
       - texte 
       - taille de la font 
       - couleur - position
    '''
    def __init__(self, texte, taille, police, couleur, position):
        self.texte = texte
        self.taille = taille
        self.couleur = couleur
        self.position = position
        self.police = police
    def affiche (self):            
        font = pygame.font.Font ( self.police, self.taille)
        text = font.render ( self.texte, 1, self.couleur) 
        text_pos = text.get_rect()
        text_pos.center = ( self.position)

        screen.blit(text, text_pos)    

class Draw_square :    
    '''
    ______Création de rectange(s)______
    2 méthodes possibles : 
        1 - gen -> dessine 1 carré 
                   - couleur
                   - position
        2 - gen_bg -> dessine les 4 carrés formant le fond
    '''
    def __init__(self):
        pass
    
    def gen(self,couleur,position):
        x = pygame.draw.rect(screen, couleur, Rect(position))
        return x
                                                 

        
    def gen_bg(self):
        n = 0
        while n != len(couleur_sombre):
            x = pygame.draw.rect(screen, couleur_sombre[n], Rect(liste_pos[n]))
            n += 1  
            
def Image(image):
    '''____Fonction de chargement d'image___
       - nom de l'image
       - attribut alpha : Bool
    '''
                                           
    x = pygame.image.load(image).convert_alpha()
    return x

class Sequence :
    
    def __init__(self):
    
        self.level = 10
        self.sequence_J = ''
        self.sequence_IA = ''
        
    def genere_sequence (self):
        
        compteur = 0
        while compteur != self.level:
            x = randrange(4)
            self.sequence_IA += str(x)
            compteur += 1
        return self.sequence_IA
            
    def update_level (self, win):
        
        if win :
            self.level += 1
        if win == False and self.level > 1:
            self.level -= 1

m = 0
clock = pygame.time.Clock()

#--- Variables --- 
compteur1, compteur2, compteur3, compteur4 = 0, 0, 0, 0 
speed = 100

#--- Variable pour les parcours de boucle et menu
tour_IA = 0
choix_menu = 0
play = 0
menu = 1
modeDeJeu = 0
highScore = 0
seq_IA = ''
seq_J = '' 
tour_Joueur = 1
hud  = pygame.image.load('data/Images/testhud.png').convert_alpha()
           #--- Boucle principale ---
while True :
                #--- Boucle menu principal ---
    while menu :
    
        speed = 80
        if compteur1 == 4:   #--- compteur pour pour la déco (changement couleur et taille
            compteur1 = 0
        if compteur2 == 8:
            compteur2 = 0
        
        screen.fill(gris)    #--- Fond     
        for event in pygame.event.get() :
            if event.type == MOUSEMOTION :
                if event.pos[0] > 180 and event.pos[0] < 415 and event.pos[1] > 240 and event.pos[1] < 260 :
                    choix_menu = 0
                if event.pos[0] > 180 and event.pos[0] < 415 and event.pos[1] > 300 and event.pos[1] < 320 :
                    choix_menu = 1
                if event.pos[0] > 230 and event.pos[0] < 360 and event.pos[1] > 360 and event.pos[1] < 385 :
                    choix_menu = 2
                if event.pos[0] > 230 and event.pos[0] < 360 and event.pos[1] > 420 and event.pos[1] < 440 :
                    choix_menu = 3
                if event.pos[0] > 230 and event.pos[0] < 360 and event.pos[1] > 480 and event.pos[1] < 500 :
                    choix_menu = 4
                                                
        Texte('Py-Simon', 130, font_char[3], couleur_sombre[compteur1],(screen.get_width()/2,40)).affiche()    #---|  
        Texte('Py-Simon', 140, font_char[3], blanc,(screen.get_width()/2,42)).affiche()                        #   | Affichage du titre
        
        rectMenu = Draw_square().gen(noir, ((100,130),(400,505)))                                              #--- Rectangle noir du menu
        
        Texte('--- Menu ---', 85, font_char[3], blanc,(screen.get_width()/2,160)).affiche()                    #--- Differents choix menu
        
        Texte('New game', 50, font_char[3], blanc,(screen.get_width()/2,250)).affiche()
        Texte('High scores', 50, font_char[3], blanc,(screen.get_width()/2,310)).affiche()
        Texte('Option', 50, font_char[3], blanc,(screen.get_width()/2,370)).affiche()
        Texte('Help', 50, font_char[3], blanc,(screen.get_width()/2,430)).affiche()
        Texte('Quit', 50, font_char[3], blanc,(screen.get_width()/2,490)).affiche()
        
                                                                                                                        
        if choix_menu == 0 :                                                                               
            Texte('New game', 50 + compteur2, font_char[3], couleur_clair[compteur1],(screen.get_width()/2,250)).affiche()
            if event.type == MOUSEBUTTONDOWN and event.button == 1:			
                menu , modeDeJeu = 0 , 1
        if choix_menu == 1 :                                                                               
            Texte('High scores', 50 + compteur2, font_char[3], couleur_clair[compteur1],(screen.get_width()/2,310)).affiche()
            if event.type == MOUSEBUTTONDOWN and event.button == 1:			
                menu , highScore = 0 , 1
        if choix_menu == 2 :                                                                               
            Texte('Option', 50 + compteur2, font_char[3], couleur_clair[compteur1],(screen.get_width()/2,370)).affiche()
            if event.type == MOUSEBUTTONDOWN and event.button == 1:			
                exit()
        if choix_menu == 3 :                                                                                
            Texte('Help', 50 + compteur2, font_char[3], couleur_clair[compteur1],(screen.get_width()/2,430)).affiche()
            if event.type == MOUSEBUTTONDOWN and event.button == 1:			
                exit()
        if choix_menu == 4 :                                                                                
            Texte('Quit', 50 + compteur2, font_char[3], couleur_clair[compteur1],(screen.get_width()/2,490)).affiche()
            if event.type == MOUSEBUTTONDOWN and event.button == 1:			
                exit() 
               
        pygame.time.wait(speed)
        pygame.display.flip()
        
        compteur1 += 1                  # incrémentation des compteur 
        compteur2 += 1                  # |

    while modeDeJeu :
    
        if compteur1 == 4:   #--- compteur pour pour la déco (changement couleur et taille
            compteur1 = 0
        if compteur2 == 8:
            compteur2 = 0
        
        screen.fill(gris)    #--- Fond
        
        for event in pygame.event.get() :
            if event.type == MOUSEMOTION :
                if event.pos[0] > 210 and event.pos[0] < 380 and event.pos[1] > 170 and event.pos[1] < 200 :
                    choix_menu = 0
                if event.pos[0] > 210 and event.pos[0] < 380 and event.pos[1] > 230 and event.pos[1] < 260 :
                    choix_menu = 1
                if event.pos[0] > 210 and event.pos[0] < 380 and event.pos[1] > 290 and event.pos[1] < 320 :
                    choix_menu = 2
                if event.pos[0] > 210 and event.pos[0] < 380 and event.pos[1] > 400 and event.pos[1] < 470 :
                    choix_menu = 3
                
        Texte('Py-Simon', 130, font_char[3], couleur_sombre[compteur1],(screen.get_width()/2,40)).affiche()    #---|  
        Texte('Py-Simon', 140, font_char[3], blanc,(screen.get_width()/2,42)).affiche()                        #   | Affichage du titre
        
        rectMenu = Draw_square().gen(noir, ((100,130),(400,400)))                                              #--- Rectangle noir du menu
        
        Texte('Easy', 50, font_char[3], blanc,(screen.get_width()/2,180)).affiche()
        Texte('Normal', 50, font_char[3], blanc,(screen.get_width()/2,240)).affiche()
        Texte('Hard', 50, font_char[3], blanc,(screen.get_width()/2,300)).affiche()    
        Texte('Menu', 50, font_char[3], blanc,(screen.get_width()/2,420)).affiche()
    
        if choix_menu == 0 :                                                                               
            Texte('Easy', 50 + compteur2, font_char[3], couleur_clair[compteur1],(screen.get_width()/2,180)).affiche()
            if event.type == MOUSEBUTTONDOWN and event.button == 1:			
                modeDeJeu , play, tour_IA = 0 , 1, 1
        if choix_menu == 1 :                                                                               
            Texte('Normal', 50 + compteur2, font_char[3], couleur_clair[compteur1],(screen.get_width()/2,240)).affiche()
            if event.type == MOUSEBUTTONDOWN and event.button == 1:			
                exit()
        if choix_menu == 2 :                                                                               
            Texte('Hard', 50 + compteur2, font_char[3], couleur_clair[compteur1],(screen.get_width()/2,300)).affiche()
            if event.type == MOUSEBUTTONDOWN and event.button == 1:			
                exit()
        if choix_menu == 3 :                                                                                
            Texte('Menu', 50 + compteur2, font_char[3], couleur_clair[compteur1],(screen.get_width()/2,420)).affiche()
            if event.type == MOUSEBUTTONDOWN and event.button == 1:			
                menu , modeDeJeu = 1 , 0
        
        pygame.time.wait(speed)
        pygame.display.flip()
        
        compteur1 += 1                  # incrémentation des compteur 
        compteur2 += 1                  # |    
    
    while highScore :    
            
        if compteur1 == 4:   #--- compteur pour pour la déco (changement couleur et taille
            compteur1 = 0
        if compteur2 == 8:
            compteur2 = 0
        
        screen.fill(gris)    #--- Fond
        
        for event in pygame.event.get() :
            if event.type == MOUSEMOTION :        
                if event.pos[0] > 210 and event.pos[0] < 380 and event.pos[1] > 400 and event.pos[1] < 470 :
                    choix_menu = 3    
        
        Texte('Py-Simon', 130, font_char[3], couleur_sombre[compteur1],(screen.get_width()/2,40)).affiche()    #---|  
        Texte('Py-Simon', 140, font_char[3], blanc,(screen.get_width()/2,42)).affiche()                        #   | Affichage du titre   
        Texte('Menu', 50, font_char[3], blanc,(screen.get_width()/2,420)).affiche()
        
        if choix_menu == 3 :                                                                                
            Texte('Menu', 50 + compteur2, font_char[3], couleur_clair[compteur1],(screen.get_width()/2,420)).affiche()
            if event.type == MOUSEBUTTONDOWN and event.button == 1:			
                menu , highScore = 1 , 0
            
        pygame.time.wait(speed)
        pygame.display.flip()
        
        compteur1 += 1                  # incrémentation des compteur 
        compteur2 += 1                  # |     


#=========================================================================================================================== Phase de Jeu     
    
    while play :                                            
                                                            
        while tour_IA:                          #------------------------------------------------------------- A l'ordinateur de jouer
            
            screen.fill(gris)    #--- Fond        
            Draw_square().gen_bg()
            
            speed = 250
            
            if seq_IA == '':                                #     si la séquence de l'ordi est vide----->  Il génere une séquence au hazard
                seq_IA = Sequence().genere_sequence()
                
            
            if compteur3 :                              # on affiche les couleurs de la séquence de l'ordi tout les 2 tour de boucles ..
                                                        
                
                if compteur4 != len(seq_IA):               
                    Draw_square().gen(couleur_clair[int(seq_IA[compteur4])],liste_pos[int(seq_IA[compteur4])])
                    compteur4 += 1
                else:
                    tour_IA, menu = 0 , 0                       # Si toute les couleurs ont bien été jouer , le tour de l'ordinateur est fini
                    tour_Joueur = 1                             # on éteint sa boucle et on active la boucle du joueur
            if compteur3 == 1:
                compteur3 -= 1
            else:
                compteur3 += 1
            

            screen.blit(hud, (0,0))
            pygame.time.wait(speed)
            pygame.display.flip()
            
        while tour_Joueur:                                     #---------------------------------------------- Au joueur de joueur 
            
            Draw_square().gen_bg()          # ----- Apelle de la class Draw_square , elle génère 4 carré de couleurs et les positiones
            
                                # ----- mise a jour de la variable speed 
            speed = 50
            
            
            for event in pygame.event.get() :                                 #         attente d'evenement joueur
                
                if event.type == QUIT:
                    exit() 
                    
                                         
                if event.type == MOUSEBUTTONUP and event.button == 1  :
                    choix_J = screen.get_at(event.pos)
                    
#               if len(seq_J) < len(seq_IA):  <--- eteint pour test
                    if choix_J == (0,90,0):                                        
                        seq_J += '0'
                        
                        Draw_square().gen((0,225,0),((0,0),(250,250)))
                        choix_J = 0
                    if choix_J == (155,0,0):
                        seq_J += '1'
                        Draw_square().gen((243,0,0),((250,0),(250,250)))
                        choix_J = 0                        
                    if choix_J == (160,150,0,255):
                        seq_J += '3'
                        Draw_square().gen((255,255,0),((250,250),(250,250)))
                        choix_J = 0
                    if choix_J == (0,55,125,255):
                        seq_J += '2'
                        Draw_square().gen((0,205,255),((0,250),(250,250)))
                        choix_J = 0
                    if event.type == KEYDOWN :
                        if event.key == K_UP:
                            m = 50    
                
            screen.blit(hud, (0,0))
            pygame.time.wait(speed)
            pygame.display.flip()



























     
    
    
    
    
    
    
